// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'TeeTree.pas' rev: 3.00

#ifndef TeeTreeHPP
#define TeeTreeHPP
#include <StdCtrls.hpp>
#include <Dialogs.hpp>
#include <TeCanvas.hpp>
#include <TeeProcs.hpp>
#include <Printers.hpp>
#include <Menus.hpp>
#include <ExtCtrls.hpp>
#include <Forms.hpp>
#include <Graphics.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Messages.hpp>
#include <Windows.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Teetree
{
//-- type declarations -------------------------------------------------------
class DELPHICLASS TCustomTreePanel;
typedef void __fastcall (__closure *TTreeClick)(TCustomTreePanel* Sender, Controls::TMouseButton Button
	, Classes::TShiftState Shift, int X, int Y);

class PASCALIMPLEMENTATION TCustomTreePanel : public Teeprocs::TCustomTeePanelExtended 
{
	typedef Teeprocs::TCustomTeePanelExtended inherited;
	
private:
	TTreeClick FOnClickTree;
	
protected:
	virtual void __fastcall DoDraw(void);
	
public:
	__fastcall virtual TCustomTreePanel(Classes::TComponent* AOwner);
	__property AnimatedZoomSteps ;
	__property TTreeClick OnClickBackground = {read=FOnClickTree, write=FOnClickTree};
public:
	/* TCustomTeePanelExtended.Destroy */ __fastcall virtual ~TCustomTreePanel(void) { }
	
public:
	/* TWinControl.CreateParented */ __fastcall TCustomTreePanel(HWND ParentWindow) : Teeprocs::TCustomTeePanelExtended(
		ParentWindow) { }
	
};

enum TTreeImageAlignment { iaAutomatic, iaLeftTop, iaRightBottom, iaLeftBottom, iaRightTop, iaLeft, 
	iaTop, iaRight, iaBottom, iaCenter };

enum TTreeShapeStyle { tssRectangle, tssCircle, tssVertLine, tssHorizLine, tssLine, tssInvertLine, tssDiamond, 
	tssTriangleTop, tssTriangleBottom, tssTriangleLeft, tssTriangleRight, tssRoundRectangle, tssCustom 
	};

enum TTreeShapeHandle { rcNone, rcLeftTop, rcRightBottom, rcLeftBottom, rcRightTop, rcLeft, rcTop, rcRight, 
	rcBottom };

class DELPHICLASS TTeeShadow;
class PASCALIMPLEMENTATION TTeeShadow : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	Graphics::TColor FColor;
	int FHorizSize;
	int FVertSize;
	Classes::TNotifyEvent IOnChange;
	void __fastcall SetColor(Graphics::TColor Value);
	void __fastcall SetHorizSize(int Value);
	void __fastcall SetVertSize(int Value);
	
public:
	__fastcall TTeeShadow(Classes::TNotifyEvent AOnChange);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property Graphics::TColor Color = {read=FColor, write=SetColor, default=12632256};
	__property int HorizSize = {read=FHorizSize, write=SetHorizSize, default=0};
	__property int VertSize = {read=FVertSize, write=SetVertSize, default=0};
public:
	/* TPersistent.Destroy */ __fastcall virtual ~TTeeShadow(void) { }
	
};

class DELPHICLASS TTeeFont;
class PASCALIMPLEMENTATION TTeeFont : public Graphics::TFont 
{
	typedef Graphics::TFont inherited;
	
private:
	int FInterCharSize;
	TTeeShadow* FShadow;
	void __fastcall SetInterCharSize(int Value);
	void __fastcall SetShadow(TTeeShadow* Value);
	
public:
	__fastcall TTeeFont(Classes::TNotifyEvent ChangedEvent);
	__fastcall virtual ~TTeeFont(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property Color ;
	__property int InterCharSize = {read=FInterCharSize, write=SetInterCharSize, default=0};
	__property TTeeShadow* Shadow = {read=FShadow, write=SetShadow};
};

enum THorizTextAlign { htaCenter, htaLeft, htaRight };

enum TVertTextAlign { vtaCenter, vtaTop, vtaBottom };

class DELPHICLASS TCustomTreeElement;
class DELPHICLASS TCustomTree;
class DELPHICLASS TTreeConnectionList;
class DELPHICLASS TTreeConnection;
class DELPHICLASS TTreeNodeShape;
class PASCALIMPLEMENTATION TTreeConnectionList : public Classes::TList 
{
	typedef Classes::TList inherited;
	
private:
	bool FVisible;
	TTreeConnection* __fastcall GetConnection(int Index);
	void __fastcall SetVisible(bool Value);
	
public:
	__fastcall TTreeConnectionList(void);
	TTreeConnection* __fastcall ToShape(TTreeNodeShape* AShape);
	__property TTreeConnection* Items[int Index] = {read=GetConnection/*, default*/};
	__property bool Visible = {read=FVisible, write=SetVisible, default=1};
public:
	/* TList.Destroy */ __fastcall virtual ~TTreeConnectionList(void) { }
	
};

class DELPHICLASS TTreeNodeCrossBox;
class DELPHICLASS TTreePen;
class PASCALIMPLEMENTATION TTreePen : public Tecanvas::TChartPen 
{
	typedef Tecanvas::TChartPen inherited;
	
public:
	/* TChartPen.Create */ __fastcall TTreePen(Classes::TNotifyEvent OnChangeEvent) : Tecanvas::TChartPen(
		OnChangeEvent) { }
	
public:
	/* TPen.Destroy */ __fastcall virtual ~TTreePen(void) { }
	
};

class DELPHICLASS TTreeBrush;
class PASCALIMPLEMENTATION TTreeBrush : public Graphics::TBrush 
{
	typedef Graphics::TBrush inherited;
	
public:
	/* TBrush.Create */ __fastcall TTreeBrush(void) : Graphics::TBrush() { }
	/* TBrush.Destroy */ __fastcall virtual ~TTreeBrush(void) { }
	
};

class PASCALIMPLEMENTATION TTreeNodeCrossBox : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	TTreePen* FBorder;
	TTreeBrush* FBrush;
	int FClickTolerance;
	TTreePen* FSignPen;
	int FSize;
	bool FVisible;
	TCustomTree* FTree;
	void __fastcall SetBorder(TTreePen* Value);
	void __fastcall SetBrush(TTreeBrush* Value);
	void __fastcall SetSignPen(TTreePen* Value);
	void __fastcall SetSize(int Value);
	void __fastcall SetVisible(bool Value);
	
public:
	__fastcall TTreeNodeCrossBox(TCustomTree* AOwner);
	__fastcall virtual ~TTreeNodeCrossBox(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	void __fastcall Draw(const tagPOINT &AtPoint, bool DrawExpanded);
	
__published:
	__property TTreePen* Border = {read=FBorder, write=SetBorder};
	__property TTreeBrush* Brush = {read=FBrush, write=SetBrush};
	__property int ClickTolerance = {read=FClickTolerance, write=FClickTolerance, default=0};
	__property TTreePen* SignPen = {read=FSignPen, write=SetSignPen};
	__property int Size = {read=FSize, write=SetSize, default=4};
	__property bool Visible = {read=FVisible, write=SetVisible, default=1};
};

enum TTreeNavigation { tnExplorer, tnNearest, tnNone };

class DELPHICLASS TNodeShapeList;
class PASCALIMPLEMENTATION TNodeShapeList : public Classes::TList 
{
	typedef Classes::TList inherited;
	
private:
	TTreeNodeShape* __fastcall GetShape(int Index);
	
public:
	__property TTreeNodeShape* Items[int Index] = {read=GetShape/*, default*/};
public:
	/* TList.Destroy */ __fastcall virtual ~TNodeShapeList(void) { }
	
public:
	/* TObject.Create */ __fastcall TNodeShapeList(void) : Classes::TList() { }
	
};

class DELPHICLASS TSelectedShapeList;
class DELPHICLASS TTreeSelectedPen;
class PASCALIMPLEMENTATION TTreeSelectedPen : public Teetree::TTreePen 
{
	typedef Teetree::TTreePen inherited;
	
public:
	__fastcall TTreeSelectedPen(Classes::TNotifyEvent OnChangeEvent);
	
__published:
	__property Color ;
	__property SmallDots ;
	__property Style ;
public:
	/* TPen.Destroy */ __fastcall virtual ~TTreeSelectedPen(void) { }
	
};

class DELPHICLASS TTreeSelectedUnFocusedPen;
class PASCALIMPLEMENTATION TTreeSelectedUnFocusedPen : public Teetree::TTreePen 
{
	typedef Teetree::TTreePen inherited;
	
public:
	__fastcall TTreeSelectedUnFocusedPen(Classes::TNotifyEvent OnChangeEvent);
	
__published:
	__property Visible ;
public:
	/* TPen.Destroy */ __fastcall virtual ~TTreeSelectedUnFocusedPen(void) { }
	
};

class PASCALIMPLEMENTATION TSelectedShapeList : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	TTreeSelectedPen* FBorder;
	TTreeSelectedUnFocusedPen* FBorderUnFocused;
	Graphics::TColor FColor;
	Graphics::TColor FColorUnFocused;
	bool FScrollToView;
	Graphics::TColor FTextColor;
	bool IFocused;
	TNodeShapeList* IList;
	TTreeNodeShape* __fastcall GetShape(int Index);
	void __fastcall SetBorder(TTreeSelectedPen* Value);
	void __fastcall SetBorderUnFocused(TTreeSelectedUnFocusedPen* Value);
	void __fastcall SetColor(Graphics::TColor Value);
	void __fastcall SetColorUnFocused(Graphics::TColor Value);
	void __fastcall SetTextColor(Graphics::TColor Value);
	
public:
	__fastcall TSelectedShapeList(TCustomTree* AOwner);
	__fastcall virtual ~TSelectedShapeList(void);
	virtual void __fastcall Assign(Classes::TPersistent* Value);
	void __fastcall Clear(void);
	int __fastcall Count(void);
	void __fastcall Delete(void);
	__property TNodeShapeList* Shapes = {read=IList};
	__property TTreeNodeShape* Items[int Index] = {read=GetShape/*, default*/};
	
__published:
	__property TTreeSelectedPen* Border = {read=FBorder, write=SetBorder};
	__property TTreeSelectedUnFocusedPen* BorderUnFocused = {read=FBorderUnFocused, write=SetBorderUnFocused
		};
	__property Graphics::TColor Color = {read=FColor, write=SetColor, default=-2147483635};
	__property Graphics::TColor ColorUnFocused = {read=FColorUnFocused, write=SetColorUnFocused, default=-2147483645
		};
	__property bool ScrollToView = {read=FScrollToView, write=FScrollToView, default=1};
	__property Graphics::TColor TextColor = {read=FTextColor, write=SetTextColor, default=-2147483634};
		
};

class DELPHICLASS TTreeShapeList;
class PASCALIMPLEMENTATION TTreeShapeList : public Teetree::TNodeShapeList 
{
	typedef Teetree::TNodeShapeList inherited;
	
public:
	bool Visible;
public:
	/* TList.Destroy */ __fastcall virtual ~TTreeShapeList(void) { }
	
public:
	/* TObject.Create */ __fastcall TTreeShapeList(void) : Teetree::TNodeShapeList() { }
	
};

class DELPHICLASS TTeeScrollBar;
class PASCALIMPLEMENTATION TTeeScrollBar : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	bool FAutomatic;
	int FMin;
	int FMax;
	bool FVisible;
	Controls::TWinControl* IOwner;
	int ICode;
	void __fastcall SetAutomatic(bool Value);
	void __fastcall SetMax(int Value);
	void __fastcall SetMin(int Value);
	void __fastcall SetVisible(bool Value);
	int __fastcall GetPageSize(void);
	void __fastcall SetPageSize(int Value);
	void __fastcall SetScrollParams(int Offset);
	int __fastcall CalcScrollOffset(int ScrollCode);
	
protected:
	void __fastcall CheckScroll(int AMin, int AMax, int AOffset, int ASize);
	
public:
	__fastcall TTeeScrollBar(Controls::TWinControl* AOwner, int ACode);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property bool Automatic = {read=FAutomatic, write=SetAutomatic, default=1};
	__property int Max = {read=FMax, write=SetMax, default=1000};
	__property int Min = {read=FMin, write=SetMin, default=0};
	__property int PageSize = {read=GetPageSize, write=SetPageSize, default=0};
	__property bool Visible = {read=FVisible, write=SetVisible, default=0};
public:
	/* TPersistent.Destroy */ __fastcall virtual ~TTeeScrollBar(void) { }
	
};

typedef void __fastcall (__closure *TClickConnectionEvent)(TTreeConnection* Sender, Controls::TMouseButton 
	Button, Classes::TShiftState Shift, int X, int Y);

typedef void __fastcall (__closure *TClickShapeEvent)(TTreeNodeShape* Sender, Controls::TMouseButton 
	Button, Classes::TShiftState Shift, int X, int Y);

typedef void __fastcall (__closure *TNotifyShapeEvent)(TTreeNodeShape* Sender);

typedef void __fastcall (__closure *TExpandingCollapsingEvent)(TTreeNodeShape* Sender, bool &Expand)
	;

typedef void __fastcall (__closure *TTreeNewConnectionEvent)(TCustomTreePanel* Sender, TTreeConnection* 
	NewConnection);

typedef void __fastcall (__closure *TTreeNewShapeEvent)(TCustomTreePanel* Sender, TTreeNodeShape* NewShape
	);

typedef void __fastcall (__closure *TNotifyShapeEventStartEdit)(TTreeNodeShape* Shape, bool &AllowEditing
	);

class DELPHICLASS TTreeNoAlignChild;
typedef void __fastcall (__closure *TTreeZoomedAreaEvent)(const Windows::TRect &R);

typedef System::TMetaClass*TTreeNodeShapeClass;

class DELPHICLASS TCustomTreeShape;
struct TTreeEvents;
class PASCALIMPLEMENTATION TCustomTree : public Teetree::TCustomTreePanel 
{
	typedef Teetree::TCustomTreePanel inherited;
	
private:
	TTreeConnectionList* FConnections;
	TTreeNodeCrossBox* FCrossBox;
	bool FDesigning;
	TTreeNodeShape* FDragged;
	Graphics::TColor FGridColor;
	int FGridStep;
	TTreeNavigation FNavigation;
	TTreeShapeHandle FResizing;
	TNodeShapeList* FRoots;
	TSelectedShapeList* FSelected;
	bool FSingleSelection;
	TTreeShapeList* FShapes;
	bool FSnapToGrid;
	TTeeScrollBar* FHorzScroll;
	TTeeScrollBar* FVertScroll;
	TClickConnectionEvent FOnClickConnection;
	TClickShapeEvent FOnClickShape;
	TClickConnectionEvent FOnDblClickConnection;
	TClickShapeEvent FOnDblClickShape;
	TNotifyShapeEvent FOnExpandedCollapsed;
	TExpandingCollapsingEvent FOnExpandingCollapsing;
	TTreeNewConnectionEvent FOnNewConnection;
	TTreeNewShapeEvent FOnNewShape;
	TNotifyShapeEvent FOnSelectShape;
	TNotifyShapeEventStartEdit FOnStartEditing;
	TNotifyShapeEvent FOnStopEditing;
	TNotifyShapeEvent FOnUnSelectShape;
	bool IsDrawing;
	int OriginalX;
	int OriginalY;
	Windows::TRect IBounds;
	TTreeNoAlignChild* IAlignChildManager[3];
	bool IEscapedConnecting;
	TTreeNodeShape* IShape1;
	TTreeNodeShape* IShape2;
	tagPOINT IFromConnect;
	tagPOINT IToConnect;
	TTreeNodeShape* IEditShape;
	bool IChangingMemo;
	MESSAGE void __fastcall CMHintShow(Messages::TMessage &Message);
	void __fastcall DrawConnecting(int x, int y, bool CheckPos);
	void __fastcall EditChange(System::TObject* Sender);
	void __fastcall EditKeyDown(System::TObject* Sender, Word &Key, Classes::TShiftState Shift);
	TTreeNodeShape* __fastcall GetShape(int Index);
	System::AnsiString __fastcall InstanceName(TTreeNodeShape* AShape);
	void __fastcall SelectedScroll(void);
	void __fastcall SetCrossBox(TTreeNodeCrossBox* Value);
	HIDESBASE void __fastcall SetDesigning(bool Value);
	void __fastcall SetGridColor(Graphics::TColor Value);
	void __fastcall SetGridStep(int Value);
	void __fastcall SetHorzScroll(TTeeScrollBar* Value);
	void __fastcall SetScrollParams(void);
	void __fastcall SetSelected(TSelectedShapeList* Value);
	void __fastcall SetShape(int Index, TTreeNodeShape* Value);
	void __fastcall SetSingleSelection(bool Value);
	void __fastcall SetVertScroll(TTeeScrollBar* Value);
	void __fastcall View3DScrolled(bool IsHoriz);
	HIDESBASE MESSAGE void __fastcall WMHScroll(Messages::TWMScroll &Msg);
	HIDESBASE MESSAGE void __fastcall WMKillFocus(Messages::TWMKillFocus &Msg);
	HIDESBASE MESSAGE void __fastcall WMSetFocus(Messages::TWMSetFocus &Msg);
	HIDESBASE MESSAGE void __fastcall WMVScroll(Messages::TWMScroll &Msg);
	
protected:
	virtual void __fastcall CreateParams(Controls::TCreateParams &Params);
	virtual void __fastcall CreateWnd(void);
	virtual void __fastcall DoDraw(void);
	int __fastcall DoExpandCollapse(TTreeNodeShape* AShape, bool Value);
	DYNAMIC void __fastcall GetChildren(Classes::TGetChildProc Proc, Classes::TComponent* Root);
	DYNAMIC Classes::TComponent* __fastcall GetChildOwner(void);
	virtual void __fastcall InternalDraw(const Windows::TRect &UserRectangle);
	DYNAMIC void __fastcall KeyDown(Word &Key, Classes::TShiftState Shift);
	virtual void __fastcall Loaded(void);
	DYNAMIC void __fastcall MouseDown(Controls::TMouseButton Button, Classes::TShiftState Shift, int X, 
		int Y);
	DYNAMIC void __fastcall MouseMove(Classes::TShiftState Shift, int X, int Y);
	DYNAMIC void __fastcall MouseUp(Controls::TMouseButton Button, Classes::TShiftState Shift, int X, int 
		Y);
	
public:
	bool AssignParent;
	bool CreateConnections;
	bool NoOwnerShapes;
	bool ShowImages;
	bool ShowText;
	bool Connecting;
	bool Editing;
	TTreeZoomedAreaEvent OnZoomedArea;
	Stdctrls::TMemo* InternalMemo;
	__fastcall virtual TCustomTree(Classes::TComponent* AOwner);
	__fastcall virtual ~TCustomTree(void);
	void __fastcall AddCloneShape(TTreeNodeShape* AShape);
	void __fastcall AddNewShape(TTreeNodeShape* AShape, int X, int Y, const System::AnsiString AText, TTreeNodeShape* 
		AParentShape);
	TTreeNodeShape* __fastcall AddShapeClass(int X, int Y, const System::AnsiString AText, TTreeNodeShape* 
		AParentShape, System::TMetaClass* AClass);
	TTreeNodeShape* __fastcall AddShape(int X, int Y, const System::AnsiString AText, TTreeNodeShape* AParentShape
		);
	TTreeNodeShape* __fastcall AddRoot(const System::AnsiString RootText);
	TTreeNodeShape* __fastcall AddRootObject(const System::AnsiString AText, void * Data);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	void __fastcall CenterInView(TCustomTreeShape* Shape, bool Animated);
	void __fastcall Clear(void);
	TTreeNodeShape* __fastcall ClickedShape(int x, int y);
	TTreeNodeShape* __fastcall CloneShape(TTreeNodeShape* AShape);
	System::AnsiString __fastcall FindFreeName(const System::AnsiString APrefix);
	void __fastcall FullExpandCollapse(bool Expand);
	TTreeNodeShape* __fastcall LoadFromTextFile(const System::AnsiString FileName);
	void __fastcall SaveEvents(TTreeEvents &SavedEvents);
	void __fastcall SetEvents(const TTreeEvents &SavedEvents);
	void __fastcall Sort(bool Ascending, bool IgnoreCase);
	bool __fastcall StartConnecting(void);
	void __fastcall StopConnecting(void);
	void __fastcall StartEditing(TTreeNodeShape* AShape);
	void __fastcall StopEditing(void);
	void __fastcall ZoomCentered(int NewZoom);
	void __fastcall ZoomFromCenter(int NewZoom, int X, int Y);
	__property TTreeNodeShape* ConnectingShape1 = {read=IShape1};
	__property TTreeNodeShape* ConnectingShape2 = {read=IShape2};
	__property TTreeConnectionList* Connections = {read=FConnections};
	__property TTreeNodeCrossBox* CrossBox = {read=FCrossBox, write=SetCrossBox};
	__property bool Designing = {read=FDesigning, write=SetDesigning, default=0};
	__property Graphics::TColor GridColor = {read=FGridColor, write=SetGridColor, default=536870911};
	__property int GridStep = {read=FGridStep, write=SetGridStep, default=10};
	__property TTreeNavigation Navigation = {read=FNavigation, write=FNavigation, default=0};
	__property TNodeShapeList* Roots = {read=FRoots};
	__property TSelectedShapeList* Selected = {read=FSelected, write=SetSelected};
	__property TTreeNodeShape* Shape[int Index] = {read=GetShape, write=SetShape/*, default*/};
	__property TTreeShapeList* Shapes = {read=FShapes};
	__property bool SingleSelection = {read=FSingleSelection, write=SetSingleSelection, default=1};
	__property bool SnapToGrid = {read=FSnapToGrid, write=FSnapToGrid, default=1};
	__property TabStop ;
	__property TTeeScrollBar* HorzScrollBar = {read=FHorzScroll, write=SetHorzScroll};
	__property TTeeScrollBar* VertScrollBar = {read=FVertScroll, write=SetVertScroll};
	__property TClickConnectionEvent OnClickConnection = {read=FOnClickConnection, write=FOnClickConnection
		};
	__property TClickShapeEvent OnClickShape = {read=FOnClickShape, write=FOnClickShape};
	__property TClickConnectionEvent OnDblClickConnection = {read=FOnDblClickConnection, write=FOnDblClickConnection
		};
	__property TClickShapeEvent OnDblClickShape = {read=FOnDblClickShape, write=FOnDblClickShape};
	__property TNotifyShapeEvent OnExpandedCollapsed = {read=FOnExpandedCollapsed, write=FOnExpandedCollapsed
		};
	__property TExpandingCollapsingEvent OnExpandingCollapsing = {read=FOnExpandingCollapsing, write=FOnExpandingCollapsing
		};
	__property TTreeNewConnectionEvent OnNewConnection = {read=FOnNewConnection, write=FOnNewConnection
		};
	__property TTreeNewShapeEvent OnNewShape = {read=FOnNewShape, write=FOnNewShape};
	__property TNotifyShapeEvent OnSelectShape = {read=FOnSelectShape, write=FOnSelectShape};
	__property TNotifyShapeEventStartEdit OnStartEditing = {read=FOnStartEditing, write=FOnStartEditing
		};
	__property TNotifyShapeEvent OnStopEditing = {read=FOnStopEditing, write=FOnStopEditing};
	__property TNotifyShapeEvent OnUnSelectShape = {read=FOnUnSelectShape, write=FOnUnSelectShape};
public:
		
	/* TWinControl.CreateParented */ __fastcall TCustomTree(HWND ParentWindow) : Teetree::TCustomTreePanel(
		ParentWindow) { }
	
};

class PASCALIMPLEMENTATION TCustomTreeElement : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	Controls::TCursor FCursor;
	TTeeFont* FFont;
	Classes::TStrings* FText;
	THorizTextAlign FHorizTextAlign;
	TVertTextAlign FVertTextAlign;
	TCustomTree* FTree;
	bool __fastcall IsFontStored(void);
	void __fastcall SetCursor(Controls::TCursor Value);
	void __fastcall SetFont(TTeeFont* Value);
	void __fastcall SetHorizTextAlign(THorizTextAlign Value);
	void __fastcall SetVertTextAlign(TVertTextAlign Value);
	
protected:
	virtual void __fastcall CanvasChanged(System::TObject* Sender);
	void __fastcall DrawText(const Windows::TRect &R);
	DYNAMIC Classes::TPersistent* __fastcall GetOwner(void);
	void __fastcall OrientRectangle(Windows::TRect &R);
	virtual void __fastcall ReadState(Classes::TReader* Reader);
	void __fastcall SetBooleanProperty(bool &Variable, bool Value);
	void __fastcall SetColorProperty(Graphics::TColor &Variable, Graphics::TColor Value);
	virtual void __fastcall SetCanvasFont(void);
	void __fastcall SetIntegerProperty(int &Variable, int Value);
	DYNAMIC void __fastcall SetParentComponent(Classes::TComponent* AParent);
	virtual void __fastcall SetText(Classes::TStrings* Value);
	virtual void __fastcall SetTree(TCustomTree* Value);
	
public:
	__fastcall virtual TCustomTreeElement(Classes::TComponent* AOwner);
	__fastcall virtual ~TCustomTreeElement(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	DYNAMIC Classes::TComponent* __fastcall GetParentComponent(void);
	DYNAMIC bool __fastcall HasParent(void);
	virtual void __fastcall Repaint(void);
	__property Controls::TCursor Cursor = {read=FCursor, write=SetCursor, default=0};
	__property TTeeFont* Font = {read=FFont, write=SetFont, stored=IsFontStored};
	__property THorizTextAlign HorizTextAlign = {read=FHorizTextAlign, write=SetHorizTextAlign, default=0
		};
	__property Classes::TStrings* Text = {read=FText, write=SetText};
	__property TCustomTree* Tree = {read=FTree, write=SetTree, stored=false};
	__property TVertTextAlign VertTextAlign = {read=FVertTextAlign, write=SetVertTextAlign, default=0};
		
};

typedef tagPOINT TTrianglePoint[3];

typedef tagPOINT TRoundRectanglePoint[16];

class DELPHICLASS TShapeGradient;
class PASCALIMPLEMENTATION TShapeGradient : public Teeprocs::TCustomTeeGradient 
{
	typedef Teeprocs::TCustomTeeGradient inherited;
	
__published:
	__property Direction ;
	__property EndColor ;
	__property StartColor ;
	__property Visible ;
public:
	/* TCustomTeeGradient.Create */ __fastcall TShapeGradient(Teeprocs::TCustomTeePanel* AOwner) : Teeprocs::
		TCustomTeeGradient(AOwner) { }
	
public:
	/* TPersistent.Destroy */ __fastcall virtual ~TShapeGradient(void) { }
	
};

class DELPHICLASS TTreeShapeAutoPosition;
class PASCALIMPLEMENTATION TTreeShapeAutoPosition : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	bool FNoLeft;
	bool FNoTop;
	Classes::TNotifyEvent IOnChange;
	bool __fastcall GetLeft(void);
	bool __fastcall GetTop(void);
	void __fastcall SetLeft(bool Value);
	void __fastcall SetTop(bool Value);
	
public:
	__fastcall TTreeShapeAutoPosition(Classes::TNotifyEvent AOnChange);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property bool Left = {read=GetLeft, write=SetLeft, default=1};
	__property bool Top = {read=GetTop, write=SetTop, default=1};
public:
	/* TPersistent.Destroy */ __fastcall virtual ~TTreeShapeAutoPosition(void) { }
	
};

typedef tagPOINT TShapePoints[101];

class PASCALIMPLEMENTATION TCustomTreeShape : public Teetree::TCustomTreeElement 
{
	typedef Teetree::TCustomTreeElement inherited;
	
private:
	Windows::TRect FAdjustedRect;
	bool FAutoSize;
	TTreeShapeAutoPosition* FAutoPosition;
	TTreePen* FBorder;
	TTreeBrush* FBrush;
	TShapeGradient* FGradient;
	bool FGradientClip;
	Graphics::TPicture* FImage;
	TTreeImageAlignment FImageAlignment;
	int FImageHeight;
	Windows::TRect FImageRect;
	int FImageWidth;
	bool FSelected;
	TTeeShadow* FShadow;
	TTreeShapeStyle FStyle;
	bool FTransparent;
	bool FVisible;
	int FX0;
	int FY0;
	int FX1;
	int FY1;
	bool INeedsAutoSize;
	bool IIsElliptic;
	TShapeGradient* __fastcall GetGradient(void);
	void __fastcall InternalDrawShape(const Windows::TRect &tmpR, Tecanvas::TCanvas3D* ACanvas, TTreeShapeStyle 
		tmpStyle);
	void __fastcall SetAutoPosition(TTreeShapeAutoPosition* Value);
	void __fastcall SetAutoSize(bool Value);
	void __fastcall SetBorder(TTreePen* Value);
	void __fastcall SetBrush(TTreeBrush* Value);
	void __fastcall SetImageAlignment(TTreeImageAlignment Value);
	void __fastcall SetImageHeight(int Value);
	void __fastcall SetImageWidth(int Value);
	void __fastcall SetGradient(TShapeGradient* Value);
	void __fastcall SetGradientClip(bool Value);
	void __fastcall SetShadow(TTeeShadow* Value);
	void __fastcall SetStyle(TTreeShapeStyle Value);
	void __fastcall SetTransparent(bool Value);
	void __fastcall SetVisible(bool Value);
	void __fastcall SetX0(int Value);
	void __fastcall SetX1(int Value);
	void __fastcall SetY0(int Value);
	void __fastcall SetY1(int Value);
	void __fastcall GetTrianglePoints(const Windows::TRect &R, int MidX, int MidY, tagPOINT * P);
	bool __fastcall IsSizeStored(void);
	Windows::TRect __fastcall Get3DRectangle();
	
protected:
	virtual TTreeImageAlignment __fastcall CalcImageAlignment(void);
	virtual void __fastcall CanvasChanged(System::TObject* Sender);
	bool __fastcall ClickedImage(int x, int y);
	void __fastcall DrawGradient(void);
	void __fastcall DrawImage(void);
	void __fastcall DrawShape(const Windows::TRect &R);
	void __fastcall DrawShapeCanvas(Tecanvas::TCanvas3D* ACanvas, const Windows::TRect &R);
	void __fastcall DrawSelectionFocus(void);
	void __fastcall GetImageSize(Graphics::TPicture* AImage, int &AWidth, int &AHeight);
	virtual Graphics::TPicture* __fastcall GetPicture(void);
	void __fastcall GetRoundRectanglePoints(const Windows::TRect &R, tagPOINT * P);
	virtual int __fastcall GetShapePoints(const Windows::TRect &R, tagPOINT * P);
	virtual void __fastcall SetCanvasFont(void);
	virtual void __fastcall SetImage(Graphics::TPicture* Value);
	virtual void __fastcall SetText(Classes::TStrings* Value);
	virtual void __fastcall SetTree(TCustomTree* Value);
	Windows::TRect __fastcall ShapeBounds();
	
public:
	__fastcall virtual TCustomTreeShape(Classes::TComponent* AOwner);
	__fastcall virtual ~TCustomTreeShape(void);
	virtual bool __fastcall Clicked(int x, int y);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	virtual void __fastcall ConnectedTo(TCustomTreeShape* ToShape, TTreeConnection* AConnection);
	virtual void __fastcall Draw(void);
	__property Windows::TRect AdjustedRectangle = {read=FAdjustedRect};
	int __fastcall XCenter(void);
	int __fastcall YCenter(void);
	void __fastcall DrawHandle(int X, int Y);
	virtual void __fastcall DrawHandles(void);
	Graphics::TPicture* __fastcall GetImage(void);
	TTreeShapeHandle __fastcall GetResizingHandle(int x, int y);
	void __fastcall GetConnectionPos(TCustomTreeShape* AShape, int &AX, int &AY);
	void __fastcall ForceRecalcSize(void);
	__property Windows::TRect ImageRect = {read=FImageRect};
	bool __fastcall InsideTreeBounds(void);
	void __fastcall RecalcSize(void);
	__property bool AutoSize = {read=FAutoSize, write=SetAutoSize, default=1};
	__property TTreeShapeAutoPosition* AutoPosition = {read=FAutoPosition, write=SetAutoPosition};
	__property TTreePen* Border = {read=FBorder, write=SetBorder};
	__property TTreeBrush* Brush = {read=FBrush, write=SetBrush};
	__property TShapeGradient* Gradient = {read=GetGradient, write=SetGradient};
	__property bool GradientClip = {read=FGradientClip, write=SetGradientClip, default=1};
	__property Graphics::TPicture* Image = {read=GetImage, write=SetImage};
	__property TTreeImageAlignment ImageAlignment = {read=FImageAlignment, write=SetImageAlignment, default=0
		};
	__property int ImageHeight = {read=FImageHeight, write=SetImageHeight, default=0};
	__property int ImageWidth = {read=FImageWidth, write=SetImageWidth, default=0};
	__property TTeeShadow* Shadow = {read=FShadow, write=SetShadow};
	__property TTreeShapeStyle Style = {read=FStyle, write=SetStyle, default=0};
	__property bool Transparent = {read=FTransparent, write=SetTransparent, default=0};
	__property bool Visible = {read=FVisible, write=SetVisible, default=1};
	__property int X0 = {read=FX0, write=SetX0, nodefault};
	__property int X1 = {read=FX1, write=SetX1, stored=IsSizeStored, nodefault};
	__property int Y0 = {read=FY0, write=SetY0, nodefault};
	__property int Y1 = {read=FY1, write=SetY1, stored=IsSizeStored, nodefault};
};

enum TTreeShapeSide { sLeft, sTop, sRight, sBottom };

enum TConnectionArrowStyle { casNone, casSolid, casLines, casSquare, casCircle, casDiamond };

class DELPHICLASS TConnectionArrowBrush;
class PASCALIMPLEMENTATION TConnectionArrowBrush : public Teetree::TTreeBrush 
{
	typedef Teetree::TTreeBrush inherited;
	
__published:
	__property Color ;
public:
	/* TBrush.Create */ __fastcall TConnectionArrowBrush(void) : Teetree::TTreeBrush() { }
	/* TBrush.Destroy */ __fastcall virtual ~TConnectionArrowBrush(void) { }
	
};

class DELPHICLASS TConnectionArrow;
class PASCALIMPLEMENTATION TConnectionArrow : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	TTreePen* FBorder;
	TConnectionArrowBrush* FBrush;
	int FSize;
	TConnectionArrowStyle FStyle;
	TTreeConnection* FOwner;
	tagPOINT IPoint;
	void __fastcall SetBorder(TTreePen* Value);
	void __fastcall SetBrush(TConnectionArrowBrush* Value);
	void __fastcall SetSize(int Value);
	void __fastcall SetStyle(TConnectionArrowStyle Value);
	
public:
	__fastcall virtual TConnectionArrow(TTreeConnection* AOwner);
	__fastcall virtual ~TConnectionArrow(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	void __fastcall Draw(int Angle);
	
__published:
	__property TTreePen* Border = {read=FBorder, write=SetBorder};
	__property TConnectionArrowBrush* Brush = {read=FBrush, write=SetBrush};
	__property int Size = {read=FSize, write=SetSize, default=4};
	__property TConnectionArrowStyle Style = {read=FStyle, write=SetStyle, nodefault};
};

class DELPHICLASS TConnectionArrowFrom;
class PASCALIMPLEMENTATION TConnectionArrowFrom : public Teetree::TConnectionArrow 
{
	typedef Teetree::TConnectionArrow inherited;
	
__published:
	__property Style ;
public:
	/* TConnectionArrow.Create */ __fastcall virtual TConnectionArrowFrom(TTreeConnection* AOwner) : Teetree::
		TConnectionArrow(AOwner) { }
	/* TConnectionArrow.Destroy */ __fastcall virtual ~TConnectionArrowFrom(void) { }
	
};

class DELPHICLASS TConnectionArrowTo;
class PASCALIMPLEMENTATION TConnectionArrowTo : public Teetree::TConnectionArrow 
{
	typedef Teetree::TConnectionArrow inherited;
	
public:
	__fastcall virtual TConnectionArrowTo(TTreeConnection* AOwner);
	
__published:
	__property Style ;
public:
	/* TConnectionArrow.Destroy */ __fastcall virtual ~TConnectionArrowTo(void) { }
	
};

enum TTreeConnectionStyle { csLine, csSides, csCurve };

class DELPHICLASS TTreeConnectionPen;
class PASCALIMPLEMENTATION TTreeConnectionPen : public Teetree::TTreePen 
{
	typedef Teetree::TTreePen inherited;
	
public:
	__fastcall TTreeConnectionPen(Classes::TNotifyEvent OnChangeEvent);
	
__published:
	__property Color ;
	__property SmallDots ;
	__property Style ;
public:
	/* TPen.Destroy */ __fastcall virtual ~TTreeConnectionPen(void) { }
	
};

class PASCALIMPLEMENTATION TTreeConnection : public Teetree::TCustomTreeElement 
{
	typedef Teetree::TCustomTreeElement inherited;
	
private:
	TConnectionArrowFrom* FArrowFrom;
	TConnectionArrowTo* FArrowTo;
	TTreeConnectionPen* FBorder;
	TTreeConnectionStyle FStyle;
	TTreeNodeShape* FFromShape;
	TTreeNodeShape* FToShape;
	tagPOINT IP0;
	tagPOINT IP1;
	tagPOINT IP2;
	tagPOINT IP3;
	bool IVisible;
	void __fastcall SetArrowFrom(TConnectionArrowFrom* Value);
	void __fastcall SetArrowTo(TConnectionArrowTo* Value);
	void __fastcall SetStyle(TTreeConnectionStyle Value);
	void __fastcall SetFromShape(TTreeNodeShape* Value);
	void __fastcall SetBorder(TTreeConnectionPen* Value);
	
protected:
	virtual void __fastcall SetTree(TCustomTree* Value);
	
public:
	__fastcall virtual TTreeConnection(Classes::TComponent* AOwner);
	__fastcall virtual ~TTreeConnection(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	bool __fastcall Clicked(int x, int y);
	void __fastcall Draw(void);
	
__published:
	__property TConnectionArrowFrom* ArrowFrom = {read=FArrowFrom, write=SetArrowFrom};
	__property TConnectionArrowTo* ArrowTo = {read=FArrowTo, write=SetArrowTo};
	__property TTreeConnectionPen* Border = {read=FBorder, write=SetBorder};
	__property Font ;
	__property HorizTextAlign ;
	__property TTreeConnectionStyle Style = {read=FStyle, write=SetStyle, default=1};
	__property Cursor ;
	__property TTreeNodeShape* FromShape = {read=FFromShape, write=SetFromShape};
	__property TTreeNodeShape* ToShape = {read=FToShape, write=FToShape};
	__property Text ;
	__property VertTextAlign ;
};

enum TTreeChildsAlignment { chaLeftBottom, chaRightBottom };

class DELPHICLASS TTreeChildsList;
class PASCALIMPLEMENTATION TTreeChildsList : public Teetree::TNodeShapeList 
{
	typedef Teetree::TNodeShapeList inherited;
	
public:
	/* TList.Destroy */ __fastcall virtual ~TTreeChildsList(void) { }
	
public:
	/* TObject.Create */ __fastcall TTreeChildsList(void) : Teetree::TNodeShapeList() { }
	
};

enum TTreeNodeImageIndex { tiNone, tiFolderClose, tiFolderOpen, tiDesktop, tiMyPC, tiNetworkNei, tiFloppy3, 
	tiRecycleBin, tiHardDisk, tiNetShare, tiComputer, tiWorld, tiFolderOpenClose, tiFolderCloseChecked, 
	tiFolderCloseUnChecked };

enum TTreeNodeShapeShowCross { scAuto, scAlways, scNever };

class PASCALIMPLEMENTATION TTreeNodeShape : public Teetree::TCustomTreeShape 
{
	typedef Teetree::TCustomTreeShape inherited;
	
private:
	TTreeNodeShapeShowCross FShowCross;
	TTreeChildsList* FChilds;
	TTreeConnectionList* FConnections;
	bool FExpanded;
	TTreeNodeImageIndex FImageIndex;
	TNodeShapeList* FParents;
	TClickShapeEvent FOnClick;
	TClickShapeEvent FOnDblClick;
	void __fastcall SetExpanded(bool Value);
	int __fastcall GetBrotherIndex(void);
	TTreeNodeShape* __fastcall GetPreviousBrother(void);
	TTreeNodeShape* __fastcall GetParent(void);
	void __fastcall InternalCalculateImageSize(void);
	bool __fastcall IsImageStored(void);
	bool __fastcall IsPositionLeftStored(void);
	bool __fastcall IsPositionTopStored(void);
	void __fastcall SetImageIndex(TTreeNodeImageIndex Value);
	void __fastcall SetParent(TTreeNodeShape* Value);
	void __fastcall SetSelected(bool Value);
	void __fastcall SetShowCross(TTreeNodeShapeShowCross Value);
	bool __fastcall ShouldDrawCross(void);
	
protected:
	virtual TTreeImageAlignment __fastcall CalcImageAlignment(void);
	int __fastcall DoExpandCollapse(bool Value);
	virtual void __fastcall DoMouseMove(Classes::TShiftState Shift, int X, int Y);
	int __fastcall RecursiveCountExpanded(void);
	void __fastcall RemovedChild(TTreeNodeShape* AChild);
	virtual void __fastcall SetImage(Graphics::TPicture* Value);
	virtual void __fastcall SetTree(TCustomTree* Value);
	
public:
	__fastcall virtual TTreeNodeShape(Classes::TComponent* AOwner);
	__fastcall virtual ~TTreeNodeShape(void);
	TTreeNodeShape* __fastcall AddBrother(const System::AnsiString AText);
	TTreeNodeShape* __fastcall AddChild(const System::AnsiString AText);
	TTreeNodeShape* __fastcall AddChildObject(const System::AnsiString AText, void * Data);
	TTreeConnection* __fastcall AddConnection(TTreeNodeShape* AToShape);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	void __fastcall BringToFront(void);
	tagPOINT __fastcall CalcXYCross(TTreeNodeShape* AParent);
	bool __fastcall CrossBoxClicked(int x, int y);
	virtual Graphics::TPicture* __fastcall GetPicture(void);
	bool __fastcall HasChilds(void);
	int __fastcall Level(void);
	int __fastcall MaxHeightExpandedChilds(void);
	void __fastcall MoveRelative(int OfsX, int OfsY, bool MoveChilds);
	void __fastcall DoDraw(void);
	void __fastcall ReCalcPositions(void);
	void __fastcall Resize(TTreeShapeHandle ACorner, int DeltaX, int DeltaY);
	void __fastcall SaveToTextFile(const System::AnsiString FileName);
	void __fastcall SelectChilds(void);
	void __fastcall SendToBack(void);
	void __fastcall SortChildsText(bool AscendingOrder, bool IgnoreCase);
	__property int BrotherIndex = {read=GetBrotherIndex, nodefault};
	__property TTreeChildsList* Childs = {read=FChilds};
	__property TTreeConnectionList* Connections = {read=FConnections};
	__property TNodeShapeList* Parents = {read=FParents};
	__property TTreeNodeShape* PreviousBrother = {read=GetPreviousBrother};
	__property bool Selected = {read=FSelected, write=SetSelected, default=0};
	
__published:
	__property AutoSize ;
	__property AutoPosition ;
	__property Border ;
	__property Brush ;
	__property Cursor ;
	__property Font ;
	__property bool Expanded = {read=FExpanded, write=SetExpanded, default=0};
	__property Gradient ;
	__property GradientClip ;
	__property Image  = {stored=IsImageStored};
	__property ImageAlignment ;
	__property ImageHeight ;
	__property TTreeNodeImageIndex ImageIndex = {read=FImageIndex, write=SetImageIndex, default=12};
	__property ImageWidth ;
	__property TTreeNodeShape* Parent = {read=GetParent, write=SetParent};
	__property Shadow ;
	__property TTreeNodeShapeShowCross ShowCross = {read=FShowCross, write=SetShowCross, default=0};
	__property Text ;
	__property HorizTextAlign ;
	__property Transparent ;
	__property Style ;
	__property VertTextAlign ;
	__property Visible ;
	__property X0  = {stored=IsPositionLeftStored};
	__property X1 ;
	__property Y0  = {stored=IsPositionTopStored};
	__property Y1 ;
	__property TClickShapeEvent OnClick = {read=FOnClick, write=FOnClick};
	__property TClickShapeEvent OnDblClick = {read=FOnDblClick, write=FOnDblClick};
};

struct TTreeEvents
{
	Controls::TMouseEvent FMouseDown;
	Controls::TMouseEvent FMouseUp;
	Controls::TMouseMoveEvent FMouseMove;
	TTreeClick FClickBackGround;
	TClickConnectionEvent FClickConnection;
	TClickShapeEvent FClickShape;
	TClickConnectionEvent FDblClickConnection;
	TClickShapeEvent FDblClickShape;
	TNotifyShapeEvent FExpandedCollapsed;
	TExpandingCollapsingEvent FExpandingCollapsing;
	TNotifyShapeEvent FSelectShape;
	TNotifyShapeEvent FUnSelectShape;
	Classes::TNotifyEvent FScroll;
} ;

class PASCALIMPLEMENTATION TTreeNoAlignChild : public System::TObject 
{
	typedef System::TObject inherited;
	
public:
	virtual bool __fastcall ConnectionClicked(TTreeConnection* AConnection, int X, int Y);
	virtual void __fastcall DrawConnection(TTreeConnection* AConnection);
	virtual tagPOINT __fastcall CalcXYCross(TTreeNodeShape* ANode, TTreeNodeShape* AParent);
public:
	/* TObject.Create */ __fastcall TTreeNoAlignChild(void) : System::TObject() { }
	/* TObject.Destroy */ __fastcall virtual ~TTreeNoAlignChild(void) { }
	
};

class DELPHICLASS TTreeExplorerAlignChild;
class PASCALIMPLEMENTATION TTreeExplorerAlignChild : public Teetree::TTreeNoAlignChild 
{
	typedef Teetree::TTreeNoAlignChild inherited;
	
public:
	virtual bool __fastcall ConnectionClicked(TTreeConnection* AConnection, int X, int Y);
	virtual void __fastcall DrawConnection(TTreeConnection* AConnection);
	virtual tagPOINT __fastcall CalcXYCross(TTreeNodeShape* ANode, TTreeNodeShape* AParent);
	int __fastcall XPosition(TTreeNodeShape* ANode);
	int __fastcall YPosition(TTreeNodeShape* ANode);
public:
	/* TObject.Create */ __fastcall TTreeExplorerAlignChild(void) : Teetree::TTreeNoAlignChild() { }
	/* TObject.Destroy */ __fastcall virtual ~TTreeExplorerAlignChild(void) { }
	
};

class DELPHICLASS TTree;
class PASCALIMPLEMENTATION TTree : public Teetree::TCustomTree 
{
	typedef Teetree::TCustomTree inherited;
	
__published:
	__property AllowPanning ;
	__property AllowZoom ;
	__property AnimatedZoom ;
	__property AnimatedZoomSteps ;
	__property BackImage ;
	__property BackImageMode ;
	__property BufferedDisplay ;
	__property CrossBox ;
	__property Designing ;
	__property Gradient ;
	__property GridColor ;
	__property GridStep ;
	__property PrintProportional ;
	__property Selected ;
	__property SingleSelection ;
	__property SnapToGrid ;
	__property View3DOptions ;
	__property HorzScrollBar ;
	__property VertScrollBar ;
	__property OnAfterDraw ;
	__property OnClickBackground ;
	__property OnClickConnection ;
	__property OnClickShape ;
	__property OnDblClickShape ;
	__property OnExpandingCollapsing ;
	__property OnExpandedCollapsed ;
	__property OnKeyDown ;
	__property OnKeyPress ;
	__property OnKeyUp ;
	__property OnNewConnection ;
	__property OnNewShape ;
	__property OnSelectShape ;
	__property OnScroll ;
	__property OnStartEditing ;
	__property OnStopEditing ;
	__property OnUnSelectShape ;
	__property OnUndoZoom ;
	__property OnZoom ;
	__property Align ;
	__property BevelInner ;
	__property BevelOuter ;
	__property BevelWidth ;
	__property BorderWidth ;
	__property BorderStyle ;
	__property Color ;
	__property DragCursor ;
	__property DragMode ;
	__property Enabled ;
	__property ParentColor ;
	__property ParentShowHint ;
	__property PopupMenu ;
	__property ShowHint ;
	__property TabOrder ;
	__property TabStop ;
	__property Visible ;
	__property OnClick ;
	__property OnDblClick ;
	__property OnDragDrop ;
	__property OnDragOver ;
	__property OnEndDrag ;
	__property OnEnter ;
	__property OnExit ;
	__property OnMouseDown ;
	__property OnMouseMove ;
	__property OnMouseUp ;
	__property OnResize ;
	__property OnStartDrag ;
public:
	/* TCustomTree.Create */ __fastcall virtual TTree(Classes::TComponent* AOwner) : Teetree::TCustomTree(
		AOwner) { }
	/* TCustomTree.Destroy */ __fastcall virtual ~TTree(void) { }
	
public:
	/* TWinControl.CreateParented */ __fastcall TTree(HWND ParentWindow) : Teetree::TCustomTree(ParentWindow
		) { }
	
};

class DELPHICLASS TTreeShapeDrag;
class PASCALIMPLEMENTATION TTreeShapeDrag : public Controls::TDragObject 
{
	typedef Controls::TDragObject inherited;
	
protected:
	virtual void __fastcall Finished(System::TObject* Target, int X, int Y, bool Accepted);
	
public:
	TTreeNodeShape* Shape;
	__fastcall virtual TTreeShapeDrag(TCustomTree* ATree);
	bool __fastcall CanBeParentOf(TTreeNodeShape* AParent, TTreeNodeShape* AShape);
	void __fastcall DragOver(int X, int Y, Controls::TDragState State, bool &Accept);
public:
	/* TObject.Destroy */ __fastcall virtual ~TTreeShapeDrag(void) { }
	
};

class DELPHICLASS TTreeClipboard;
class PASCALIMPLEMENTATION TTreeClipboard : public Teetree::TCustomTree 
{
	typedef Teetree::TCustomTree inherited;
	
public:
	void __fastcall Copy(TCustomTree* SourceTree);
	void __fastcall Cut(TCustomTree* SourceTree);
	void __fastcall Paste(TCustomTree* DestTree);
public:
	/* TCustomTree.Create */ __fastcall virtual TTreeClipboard(Classes::TComponent* AOwner) : Teetree::
		TCustomTree(AOwner) { }
	/* TCustomTree.Destroy */ __fastcall virtual ~TTreeClipboard(void) { }
	
public:
	/* TWinControl.CreateParented */ __fastcall TTreeClipboard(HWND ParentWindow) : Teetree::TCustomTree(
		ParentWindow) { }
	
};

typedef void __fastcall (__closure *TTreeForEachCustomShapeProc)(const System::AnsiString AGroup, const 
	System::AnsiString AName, System::TMetaClass* AClass);

//-- var, const, procedure ---------------------------------------------------
#define TeeDefaultBoxSize (Byte)(4)
#define TeeDefaultArrowSize (Byte)(4)
#define TeeDefaultGridStep (Byte)(10)
#define TreeDefaultAnimatedSteps (Byte)(3)
#define TeeDefaultMaxScroll (Word)(1000)
#define TeeDefaultMinScroll (Byte)(0)
#define TeeTree_DefaultXPosition (Byte)(20)
#define TeeTree_DefaultYPosition (Byte)(2)
extern PACKAGE int TeeLineClickTolerance;
extern PACKAGE Controls::TCursor TeeConnectionCursor;
extern PACKAGE int TreeHorizMarginDefault;
extern PACKAGE int TreeVertMarginDefault;
extern PACKAGE int TeeScrollSmallInc;
extern PACKAGE int TeeScrollLargeInc;
extern PACKAGE int TeeCrossBoxHorizMargin;
extern PACKAGE int TeePictureHorizMargin;
extern PACKAGE int TeePictureVertMargin;
extern PACKAGE int TeeTreeArrowMargin;
extern PACKAGE int TeeTextHorizMargin;
extern PACKAGE int TreeZ;
#define TreeMsg_Browse "&Browse Back Image..."
#define TreeMsg_Clear "C&lear Back Image"
#define TreeMsg_TeeTree "TeeTree 1.02"
#define TeeMsg_TreeVersion "TeeTree 1.02 Trial"
#define TeeMsg_TreeProdName "TeeTree 1.02"
#define TeeMsg_TreeCopyright " 1998 by David Berneda"
#define TeeMsg_TreePrintPreview "&Print Preview..."
#define TeeMsg_TreeExportChart "E&xport Tree..."
#define TeeMsg_TreeAbout "&About TeeTree..."
#define TeeMsg_TreeLoad "&Load Tree..."
#define TeeMsg_TreeFiles "TeeTree 1.0 files (*.tee)|*.TEE"
#define TeeMsg_TreeEdit "E&dit Tree..."
#define TeeMsg_TreeSureDelete "Sure to Delete Nodes?"
#define TreeMsg_Connection "Connection"
#define TreeMsg_CannotSetShape "Use the Tree property. Shapes property is read-only"
#define TreeMsg_CompNamePrefix "TreeShape"
#define TreeMsg_VersionsAbout "For Borland Delphi 4,3 and C++ Builder 3"
#define TeeMsg_TreeProdNameOffer "TeeTree 1.02  (Offer Price for already TeeChart Pro Custom"\
	"ers)"
#define TeeMsg_TreeProdNameNormal "TeeTree 1.02  (Normal Price)"
#define TeeMsg_TreeSourceCode "100% Source Code ! +18000 lines. No Run-Time Royalties !"
extern PACKAGE Classes::TList* TreeCustomShapes;
extern PACKAGE void __fastcall TreeLogoSetPicture(Graphics::TPicture* Picture);
extern PACKAGE void __fastcall TeeShowTreeAbout(bool ShowOrder);
extern PACKAGE bool __fastcall Intersect(const Windows::TRect &R1, const Windows::TRect &R2);
extern PACKAGE void __fastcall RegisterCustomTreeShape(const System::AnsiString AGroup, const System::AnsiString 
	AName, System::TMetaClass* AClass);
extern PACKAGE void __fastcall TreeForEachCustomShape(TTreeForEachCustomShapeProc ForEachProc);

}	/* namespace Teetree */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Teetree;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// TeeTree
